#!/usr/bin/env node

const path = require("path");
const { program } = require("commander");
const inquirer = require("inquirer");
const childProcess = require("child_process");

program
  .arguments("<dir>")
  .description("this is a directory!")
  .action(dir => {
    return inquirer
      .prompt([
        {
          type: "list",
          name: "framework",
          message: "which framework do you link?",
          choices: ["node", "vue"]
        }
      ])
      .then(answers => {
        console.log("resule >>> ", dir, answers); // result >>> test { framework: "vue" }

        // 通过 git 下载文件
        // git clone xxx dir
        // process.cwd()：当前执行脚本文件的地址
        const fulldir = path.resolve(process.cwd(), dir);
        console.log("process.cwd() >>>>> ", process.cwd()); // F:\
        console.log("fulldir >>>>> ", fulldir); // F:\vue-startup

        // git clone 要使用 https 协议
        // git clone 的第四个参数：要写入的目录位置
        const command = `git clone https://gitee.com/MiracleSol/${answers.framework}-boilerplate.git ${fulldir}`;
        console.log("command >>> ", command); // git clone https://gitee.com/MiracleSol/vue-boilerplate.git F:\vue-startup
        
        // childProcess.exec：执行命令
        childProcess.execSync(command);
      });
  });

program.parse(process.argv);
